\section{Related Work}
\label{sec:RelWork}
Solutions for Energy and Power Aware Job Scheduling and Resource Management have been approached from several sides, the related work section will look at Academic Research Projects.  There are also solutions provided by vendors, but these will not be reviewed in this paper.


%Find different headings:
%\subsection{Accademic Research}
Several research avenues have been explored in order to curtail the power 
and energy consumption of HPC systems. In the rest of this section we are 
going to present a brief overview of the techniques found in the 
literature and current state-of-the-art.

A detailed survey of the research on power management techniques for high
performance systems can be found in \cite{maiterth2017power, Liu2010, cameron2005high}.
As clearly pointed out by Hsu et al.\cite{HsuFA05}, a change of the
current perspective is required: 
the focus must shift from performance-based metrics (such as the 
performance-power ration) to new ones which  take into account different
aspects of the problem, i.e. integrating the notions of total cost of
ownership, productivity and reliability. 

Several works aim at curbing the overall power consumption at the supercomputer level., i.e. power capping. 
Sarood et al. \cite{Sarood2014} describe an integer linear programming model to enforce power capping in an HPC cluster through over-provisioning. Their approach combines over-provisioning with a power-aware scheduler.  
Mammela et al. \cite{mammela2012energy} present an energy-aware scheduler that turns off idle nodes every time the scheduler detects that no activity can be scheduled for a sufficiently long time on a certain node. 

Many approaches take advantage of ``moldable jobs'', i.e., jobs which can run with different configurations (number of nodes, cores or threads) \cite{Bailey:2014:ACS:2703009.2706736,Patki:2015:PRM:2749246.2749262,Mualem:2001:UPW:380314.380315}.  Given the current power consumption and power budget, the best configuration is chosen for each job before its start. Other authors tried to exploit the power and performance variability among nodes and components within the same system \cite{Inadomi:2015:AMI:2807591.2807638,shoukourian2015adviser}.

Dynamic Voltage and Frequency Scaling (DVFS) allows one to exchange processor performance for lower power consumption and has been explored as a means to increase the supercomputer's energy-efficiency \cite{8081827, 10.1007/978-3-319-07518-1_25,Freeh:2007:AET:1263127.1263246}. However, reducing the operating clock may increase the duration of the applications which run on the now more energy efficient resources \cite{8081827, 10.1007/978-3-319-07518-1_25, Hsu:2005:PRS:1105760.1105766}. Approaches to overcome this issue take advantage of compute, memory, communication phases \cite{Freeh:2007:AET:1263127.1263246} or heterogeneous nodes \cite{8081827}.
An extension of these approaches into job scheduling is discussed by Etinski et al. \cite{Etinski2010,Etinski:2012:PJS:2400744.2400966}, which extends the standard job scheduling algorithm with power budgeting capability through DVFS. 

An alternative to the direct control of frequency scaling is Intel's Running Average Power Limit (RAPL) \cite{David:2010:RMP:1840845.1840883}, which provides a software configurable and hardware enforced power cap. Several works have combined Intel's RAPL feature with job scheduling algorithms\cite{Bodas:2014:SPS:2689710.2689713,Ellsworth:2015:DPS:2807591.2807643}. These approaches rely on allocating a reduced power budget to each node and sockets. Ellsworth et al. \cite{Ellsworth:2015:DPS:2807591.2807643} dynamically share the budget between nodes aiming to give more power to the nodes which run critical jobs and processes. 

An orthogonal approach to achieving a system level power budget does not limit the performance of the processing elements, but limits the jobs concurrently running on the computational resources \cite{BorghesiHPCS15, BorghesiCP15, BorghesiISC16}. 
 
Other work focuses on minimizing the energy consumption and/or the related energy costs \cite{10.1007/978-3-319-07518-1_25,BHATTACHARYA2013183,KHEMKA201514,Leal2016}. These energy aware schedulers and resource managers act on the job execution order alone, without requiring any hardware modification nor any change in the operational frequencies of the computing nodes. 

A very important aspect for energy and power aware job schedulers and resource managers is knowledge of an application's features before its execution; this allows for the JSRM technologies to make EPA informed decisions. Application features may include the application's tag, historical data and model regression \cite{shoukourian2014predicting},  user's meta-information, such as a tag identifying similar jobs\cite{10.1007/978-3-319-07518-1_25}, machine learning techniques and job submission information \cite{BorghesiISC16,Sirbu:2016:PCM:2990973.2991005}. 

From the above discussion, we can see that in recent years several techniques, algorithms and strategies have been proposed in the state-of-the-art for energy and power aware job schedulers and resource managers in the high performance computing domain. The findings of the survey described in this paper show early attempts at deploying EPA JSRM technologies on large scale production deployments in supercomputing centers. Understanding this gap between research and current practice trends can be very important in setting future research agendas.  


